/*
 * Copyright (C) 2003 TAM(Teppei Tamra) <tam-t@par.odn.ne.jp>
 */

#ifndef _TAVIA_H_
#define _TAVIA_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qsplitter.h>
#include <kmainwindow.h>
#include <kdockwidget.h>
#include <klocale.h>
#include <kaboutdata.h>
#include <kglobal.h>
#include <kurl.h>
#include <kmdimainfrm.h>
#include <kparts/browserextension.h>
#include <khtml_settings.h>
#include <taviamdifrm.h>
#include <taviatabboxframe.h>
#include <taviasidebar.h>
#include <taviaviewmanager.h>

class TaviaSidebarContents;

/**
 * @short Application Main Window
 * @author TAM(Teppei Tamra) <tam-t@par.odn.ne.jp>
 * @version 0.1
 */
class tavia : public TaviaMdiFrm
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    tavia();

    /**
     * Default Destructor
     */
    virtual ~tavia();


protected:
    TaviaViewManager * vm;
    TaviaTabBoxFrame * tab;
    TaviaMdiFrm *view;
    KAction *fullScreenToggle;
    TaviaSidebar *sidebar;
    bool resizeReady;


public slots:
    void bugReport();
    virtual void resize(int h,int w);
    void resize(const QSize &s);

protected slots:
    void slotFullScreenToggle();
    void slotDockMenuPopup();
    void activePart(KParts::Part *part);

signals:
    void partAdd(KParts::Part *part);

protected slots:
    bool close();
};

#endif // _TAVIA_H_
