/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAPARTSVIEWHISTORYPOPUP_H
#define TAVIAPARTSVIEWHISTORYPOPUP_H

#include <qwidget.h>
#include <qlabel.h>
#include <qptrlist.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qlayout.h>
#include <taviapartsview.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaPartsViewHistoryPopup;

class TaviaPartsViewHistoryPopupItem : public QWidget
{
Q_OBJECT
public:
    friend class TaviaPartsViewHistoryPopup;
    TaviaPartsViewHistoryPopupItem(QWidget *parent,int entry,const QString &caption,const QString &url,const QPixmap &thumbnail,const QPixmap &defaultPix,const QPixmap &activePix, const char *name = 0);

    ~TaviaPartsViewHistoryPopupItem();

protected:
    QString url;
    QString title;
    int historyEntry;
    QLabel *label;
    QPixmap defaultPix;
    QPixmap activePix;
    bool pressed;
    bool hover;
    QLabel *description;
protected:
    void setPixmap(const QPixmap &pix);
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void mousePressEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *e);
protected slots:
    void hoverCheck();
signals:
    void clicked(int p);
};

class TaviaPartsViewHistoryPopup : public QWidget
{
Q_OBJECT
public:
    TaviaPartsViewHistoryPopup(TaviaPartsView *parent, const char *name = 0,WFlags f = 0);

    ~TaviaPartsViewHistoryPopup();

protected:
    TaviaPartsView *partView;
    QPtrList<TaviaPartsViewHistoryPopupItem> thumbnail;
    QPoint mPos;
protected:
    virtual void mouseReleaseEvent(QMouseEvent *e);
    virtual void hideEvent(QHideEvent *e);
    virtual void wheelEvent(QWheelEvent *e);
signals:
    void historyEnter(int e);
};

#endif
