/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAPARTSVIEWNAVIGATION_H
#define TAVIAPARTSVIEWNAVIGATION_H

#include <kbookmarkmenu.h>
#include <kbookmarkmanager.h>
#include <ktoolbar.h>
#include <kaction.h>
#include <taviapartsview.h>
#include <qwidget.h>
#include <qlayout.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaPartsView;

class TaviaPartsViewNavigation : public QWidget , KBookmarkOwner, KXMLGUIClient
{
Q_OBJECT
public:
    TaviaPartsViewNavigation(TaviaPartsView *parent = 0, const char *name = 0);

    ~TaviaPartsViewNavigation();
    virtual void openBookmarkURL(const QString &url);
    virtual QString currentTitle() const;
    virtual QString currentURL() const;

protected:
    KToolBar *toolBar;
    KAction *back;
    KAction *hstr;
    KAction *forw;
    KAction *reld;
    KAction *stop;
    TaviaPartsView *view;
    KAction *bkmk;
    KPopupMenu *bookmarkMenu;
public slots:
    void updateButtonStatus();
protected slots:
    void bookmarkPopup();
};

#endif
