/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviatabbox.h"
#include <kdebug.h>

TaviaTabBox::TaviaTabBox(QWidget * parent, const char * name, WFlags f)
 : QScrollView(parent, name, f)
{
    size = 100;
    setMinimumSize(QSize(100,100));
    setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    enableClipper(false);
    setVScrollBarMode(QScrollView::AlwaysOff);
    setHScrollBarMode(QScrollView::AlwaysOff);

    /*
    TaviaTabButton *t1 = new TaviaTabButton(this);
    TaviaTabButton *t2 = new TaviaTabButton(this);
    TaviaTabButton *t3 = new TaviaTabButton(this);
    addChild(t1,0,0);
    addChild(t2,t1->width(),0);
    addChild(t3,t1->width() + t2->width(),0);
    resizeContents(t1->width() + t2->width() + t3->width(),t1->height());
    */
}


TaviaTabBox::~TaviaTabBox()
{
}



/*!
    \fn TaviaTabBox::addButton()
 */
TaviaTabButton * TaviaTabBox::addButton()
{
    TaviaTabButton *b = new TaviaTabButton(this);
    buttons.append(b);
    addChild(b);
    updateBox();
    return(b);
}


/*!
    \fn TaviaTabBox::delButton(TaviaTabButton *b)
 */
void TaviaTabBox::delButton(TaviaTabButton *b)
{
    //buttons.remove(buttons.find(b));
    buttons.remove(b);
    removeChild(b);
    delete b;
    updateBox();
}


/*!
    \fn TaviaTabBox::updateBox()
 */
void TaviaTabBox::updateBox()
{
    unsigned int i = 0;
    bool v = vertical;
    if (v) size = visibleWidth();
    else size = visibleHeight();
    if (!v) resizeContents(buttons.count() * size,size);
    else resizeContents(size,buttons.count() * size);
    int x = 0;
    for(;i < buttons.count();i ++) {
        buttons.at(i)->setSize(size);
        // Ĥδ֤hiddenˤʤäƤ?!
        buttons.at(i)->show();
        //if (!v) moveChild(buttons.at(i),i * size,0);
        //else moveChild(buttons.at(i),0,i * size);
        if (!v) {
            moveChild(buttons.at(i),x,0);
            //x += buttons.at(i)->width();
            x += size;
        } else {
            moveChild(buttons.at(i),0,x);
            //x += buttons.at(i)->height();
            x += size;
        }
        kdDebug() << "BUTTON: " << buttons.at(i) << endl;
    }
    updateContents();
    kdDebug() << "contentsSize: " << contentsWidth() << "x" << contentsHeight() << endl;
    kdDebug() << "buttonsCount: " << buttons.count() << endl;
}




/*!
    \fn TaviaTabBox::downScroll()
 */
void TaviaTabBox::downScroll()
{
    if (vertical) scrollBy(0,size);
    else scrollBy(size,0);
}


/*!
    \fn TaviaTabBox::upScroll()
 */
void TaviaTabBox::upScroll()
{
    if (vertical) scrollBy(0,0 - size);
    else scrollBy(0 - size,0);
}


/*!
    \fn TaviaTabBox::contentsWheelEvent(QWheelEvent * e)
 */
void TaviaTabBox::contentsWheelEvent(QWheelEvent * e)
{
    if (e->state() == Qt::ControlButton) {
        if (e->delta() >= 0) emit extWheelActionUp();
        else emit extWheelActionDown();
    } else {
        if (e->delta() >= 0) {
            upScroll();
        } else {
            downScroll();
        }
    }

}


/*!
    \fn TaviaTabBox::wheelAction(QWheelEvent * e)
 */
void TaviaTabBox::wheelAction(QWheelEvent * e)
{
    contentsWheelEvent(e);
}
