/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviatabboxframe.h"
#include <kglobal.h>
#include <kiconloader.h>

TaviaTabBoxFrame::TaviaTabBoxFrame(QWidget *parent, const char *name)
 : QWidget(parent, name)
{
    setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    vUp = new QToolButton(this);
    vUp->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Minimum);
    vUp->setIconSet(KGlobal::instance()->iconLoader()->loadIconSet("2uparrow",KIcon::Toolbar,KIcon::SizeSmall));
    vDown = new QToolButton(this);
    vDown->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Minimum);
    vDown->setIconSet(KGlobal::instance()->iconLoader()->loadIconSet("2downarrow",KIcon::Toolbar,KIcon::SizeSmall));
    hUp = new QToolButton(this);
    hUp->setSizePolicy(QSizePolicy::Minimum,QSizePolicy::Expanding);
    hUp->setIconSet(KGlobal::instance()->iconLoader()->loadIconSet("2leftarrow",KIcon::Toolbar,KIcon::SizeSmall));
    hDown = new QToolButton(this);
    hDown->setSizePolicy(QSizePolicy::Minimum,QSizePolicy::Expanding);
    hDown->setIconSet(KGlobal::instance()->iconLoader()->loadIconSet("2rightarrow",KIcon::Toolbar,KIcon::SizeSmall));
    tabbox = new TaviaTabBox(this);
    tabbox->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    QVBoxLayout *vbox = new QVBoxLayout(this);
    QHBoxLayout *hbox = new QHBoxLayout(this);
    hbox->addWidget(hUp);
    hbox->addWidget(tabbox);
    hbox->addWidget(hDown);
    vbox->addWidget(vUp);
    vbox->addLayout(hbox);
    vbox->addWidget(vDown);

    connect(vUp,SIGNAL(clicked()),tabbox,SLOT(upScroll()));
    connect(vDown,SIGNAL(clicked()),tabbox,SLOT(downScroll()));
    connect(hUp,SIGNAL(clicked()),tabbox,SLOT(upScroll()));
    connect(hDown,SIGNAL(clicked()),tabbox,SLOT(downScroll()));
    
}


TaviaTabBoxFrame::~TaviaTabBoxFrame()
{
}



/*!
    \fn TaviaTabBoxFrame::resizeEvent(QResizeEvent *e)
 */
void TaviaTabBoxFrame::resizeEvent(QResizeEvent *e)
{
    if (height() > width()) {
        tabbox->vertical = true;
        vUp->show();
        vDown->show();
        hUp->hide();
        hDown->hide();
    } else {
        tabbox->vertical = false;
        vUp->hide();
        vDown->hide();
        hUp->show();
        hDown->show();
    }
    tabbox->updateBox();
}
