/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *   Copyright (C) 2004 by kzk(Kazuki Ohta)                                *
 *   mover@hct.zaq.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAURLBAR_H
#define TAVIAURLBAR_H

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <kglobal.h>
#include <kiconloader.h>
#include <klocale.h>
#include <kdebug.h>
#include <kcombobox.h>
#include <kurlcombobox.h>
#include <qtoolbutton.h>
#include <kglobalsettings.h>
#include <kurlcompletion.h>
#include <kcompletion.h>

class KComboBox;

/**
@author TAM(Teppei Tamra)
*/

class TaviaURLBar : public QWidget
{
Q_OBJECT
public:
    TaviaURLBar(QWidget *parent = 0, const char *name = 0, WFlags f = 0);
    ~TaviaURLBar();

    void setEditURL(const KURL &url);

protected:
    QStringList checkPrefixes(const QString &str);

protected:
    static KCompletion * mCompletion;
    KComboBox * uCombo;

    QToolButton * urlEnter;
    QToolButton * urlErase;

public slots:
    virtual void setFocus();
    virtual void setEnabled(bool b);
    void addURLHistory(const KURL &url);
    void setEditText(const QString &text);
    
protected slots:
    void clearURLBar();
    void slotReturnPressed();
    void slotEnterURL(const KURL &url);
    void slotActivated(const QString&);
    void slotHighlighted(const QString&);

    /* for completion */
    void slotCompletionModeChanged(KGlobalSettings::Completion);
    void slotMakeCompletion(const QString &str);
    void slotMatch(const QString &str);
    void completionConnect();

signals:
    void enterURL(const KURL &url);
};

#endif
